rawset(_G, "aTourney", {}) -- ATO global namespace, see exposed value descriptions below
aTourney.tourneyInSet = false -- Bool. If true, a tourney set is currently ongoing.
aTourney.tourneyMapList = {} -- List of upcoming maps (numerical IDs) in a defined set. Keep in mind these get removed one by one as the set progresses.
aTourney.isRandomSet = false -- Bool. If true, the set currently being played is random and will not have map data.
aTourney.raceNumber = 0 -- Int. The current race number in the set. This doesn't increment until intermission starts.
aTourney.totalMaps = 0 -- Int. The number of maps in the set. Should be set up and ready to read when a tourney set begins.
aTourney.bluetotalscore = 0 -- Int. Friendmod specific. Holds the total score for the entire tourney set for the blue team.
aTourney.orangetotalscore = 0 -- Int. Same as above but orange.

-- HUD related stuff for reading and modification in external scripts
-- Like if you wanted to add onto the existing scroll system this uses
aTourney.slideRun = "left"
aTourney.slideValue = -50
aTourney.slideDelay = 0

-- A value that can be used to check that this is the version of ATO used by TRC
aTourney.trcVersion = true

--Toggles pausing at the end of the last map in a set
aTourney.PauseOnSetEnd = CV_RegisterVar({
	name = "ato_pausingonsetend",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})
--Toggles printing spectator's scores to log at end of every round
aTourney.LogSpectatorScores = CV_RegisterVar({
	name = "ato_logspectatorscores",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

--Toggles showing next map icon in a defined set
aTourney.ShowNextMap = CV_RegisterVar({
	name = "ato_shownextmap",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

--THIS VALUE IS MANAGED BY AUTOTOGGLE IF ENABLED
aTourney.whitelistEnabled = CV_RegisterVar({ --This starts kicking everyone but whitelisters and admins when on.
	name = "ato_whitelist_enabled",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

aTourney.autoToggle = CV_RegisterVar({ --Automatically turns on whitelist when a set starts, and turns off after
	name = "ato_whitelist_autotoggle",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

aTourney.autoPopulate = CV_RegisterVar({ --Automatically clears and refills the whitelist with the current lobby when a set starts
	name = "ato_whitelist_autopopulate",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

aTourney.chatMute = CV_RegisterVar({ --Toggles if chat messages should be blocked from unverified users while whitelist is on
	name = "ato_whitelist_chatmute",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
})

aTourney.kickDelay = CV_RegisterVar({ --How many seconds before someone is booted
	name = "ato_whitelist_kickdelay",
	defaultvalue = 7,
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned,
})