-- Automates handling of tourney sets
-- By Onyo

-- Contains modifications for TRCups by NepDisk
-- Like adding current cup name to the intermission display 
-- along with clearing the TR_Cups Table itself

--          Script vars
local didAnnounce = false
local clearscoreflag = false
local RS_THINK, RS_VOTE, RS_INT = 1, 2, 3
local roundstatus = RS_THINK
local tIntCounter = 20 * TICRATE --Placeholder, this script is loaded before inttime is set in a server's config file
local staticIntRef = 20 * TICRATE 
local logMapBuffer = ""
local savedScores = {}
local lastRaceOfRandom = false
local didCommand = false

--Intermission HUD stuff (did they finally add a hook in DRRR?)
-- Globalized for external script reading
local slideRun = aTourney.slideRun
local slideValue = aTourney.slideValue
local slideDelay = aTourney.slideDelay

if ULTIMATEDRAWSTRING then 
	FNT_NewFont("FONT_S2FNT",{prefix = "S2FNT%03d", monospacewidth = 20, spacewidth = 12})
end

--Team color reference for score reports
--Expanded to include custom client colors - Onyo
local colLookup = { -- thanks ampersand
	[SKINCOLOR_WHITE] = "\x80",
	[SKINCOLOR_SILVER] = "\x80",
	[77] = "\x80",
	[101] = "\x80",
	[104] = "\x80",
	[131] = "\x80",
	[184] = "\x80",
	[189] = "\x80",
	[90] = "\x81",
	[93] = "\x81",
	[94] = "\x81",
	[125] = "\x81",
	[126] = "\x81",
	[127] = "\x81",
	[197] = "\x81",
	[198] = "\x81",
	[200] = "\x81",
	[203] = "\x81",
	[SKINCOLOR_POPCORN] = "\x82",
	[SKINCOLOR_QUARRY] = "\x82",
	[SKINCOLOR_YELLOW] = "\x82",
	[SKINCOLOR_MUSTARD] = "\x82",
	[SKINCOLOR_CROCODILE] = "\x82",
	[SKINCOLOR_OLIVE] = "\x82",
	[114] = "\x82",
	[154] = "\x82",
	[185] = "\x82",
	[SKINCOLOR_LIME] = "\x83",
	[SKINCOLOR_HANDHELD] = "\x83",
	[SKINCOLOR_MOSS] = "\x83",
	[SKINCOLOR_CAMOUFLAGE] = "\x83",
	[SKINCOLOR_ROBOHOOD] = "\x83",
	[SKINCOLOR_MINT] = "\x83",
	[SKINCOLOR_GREEN] = "\x83",
	[SKINCOLOR_PINETREE] = "\x83",
	[67] = "\x83",
	[66] = "\x83",
	[SKINCOLOR_EMERALD] = "\x83",
	[SKINCOLOR_SWAMP] = "\x83",
	[SKINCOLOR_DREAM] = "\x83",
	[119] = "\x83",
	[155] = "\x83",
	[156] = "\x83",
	[159] = "\x83",
	[160] = "\x83",
	[162] = "\x83",
	[164] = "\x83",
	[165] = "\x83",
	[166] = "\x83",
	[168] = "\x83",
	[169] = "\x83",
	[179] = "\x83",
	[84] = "\x84",
	[85] = "\x84",
	[86] = "\x84",
	[87] = "\x84",
	[123] = "\x84",
	[124] = "\x84",
	[172] = "\x84",
	[174] = "\x84",
	[180] = "\x84",
	[181] = "\x84",
	[188] = "\x84",
	[191] = "\x84",
	[SKINCOLOR_CINNAMON] = "\x85",
	[SKINCOLOR_RUBY] = "\x85",
	[SKINCOLOR_RASPBERRY] = "\x85",
	[SKINCOLOR_CHERRY] = "\x85",
	[SKINCOLOR_RED] = "\x85",
	[SKINCOLOR_CRIMSON] = "\x85",
	[SKINCOLOR_MAROON] = "\x85",
	[SKINCOLOR_FLAME] = "\x85",
	[SKINCOLOR_SCARLET] = "\x85",
	[SKINCOLOR_KETCHUP] = "\x85",
	[137] = "\x85",
	[138] = "\x85",
	[139] = "\x85",
	[140] = "\x85",
	[202] = "\x85",
	[SKINCOLOR_GREY] = "\x86",
	[SKINCOLOR_NICKEL] = "\x86",
	[SKINCOLOR_BLACK] = "\x86",
	[SKINCOLOR_SKUNK] = "\x86",
	[SKINCOLOR_JET] = "\x86",
	[102] = "\x86",
	[103] = "\x86",
	[132] = "\x86",
	[SKINCOLOR_DAWN] = "\x87",
	[SKINCOLOR_SUNSET] = "\x87",
	[SKINCOLOR_CREAMSICLE] = "\x87",
	[SKINCOLOR_ORANGE] = "\x87",
	[SKINCOLOR_PUMPKIN] = "\x87",
	[SKINCOLOR_ROSEWOOD] = "\x87",
	[SKINCOLOR_BURGUNDY] = "\x87",
	[SKINCOLOR_TANGERINE] = "\x87",
	[112] = "\x87",
	[141] = "\x87",
	[149] = "\x87",
	[68] = "\x88",
	[69] = "\x88",
	[70] = "\x88",
	[71] = "\x88",
	[72] = "\x88",
	[73] = "\x88",
	[74] = "\x88",
	[75] = "\x88",
	[83] = "\x88",
	[120] = "\x88",
	[121] = "\x88",
	[122] = "\x88",
	[167] = "\x88",
	[171] = "\x88",
	[173] = "\x88",
	[175] = "\x88",
	[176] = "\x88",
	[177] = "\x88",
	[178] = "\x88",
	[192] = "\x88",
	[88] = "\x89",
	[89] = "\x89",
	[91] = "\x89",
	[95] = "\x89",
	[96] = "\x89",
	[97] = "\x89",
	[98] = "\x89",
	[99] = "\x89",
	[128] = "\x89",
	[147] = "\x89",
	[193] = "\x89",
	[194] = "\x89",
	[195] = "\x89",
	[SKINCOLOR_GOLD] = "\x8A",
	[SKINCOLOR_ROYAL] = "\x8A",
	[SKINCOLOR_BRONZE] = "\x8A",
	[SKINCOLOR_COPPER] = "\x8A",
	[79] = "\x8A",
	[111] = "\x8A",
	[113] = "\x8A",
	[142] = "\x8A",
	[143] = "\x8A",
	[144] = "\x8A",
	[153] = "\x8A",
	[SKINCOLOR_ARTICHOKE] = "\x8B",
	[SKINCOLOR_VOMIT] = "\x8B",
	[SKINCOLOR_GARDEN] = "\x8B",
	[SKINCOLOR_TEA] = "\x8B",
	[SKINCOLOR_PISTACHIO] = "\x8B",
	[115] = "\x8B",
	[116] = "\x8B",
	[117] = "\x8B",
	[118] = "\x8B",
	[150] = "\x8B",
	[157] = "\x8B",
	[158] = "\x8B",
	[161] = "\x8B",
	[163] = "\x8B",
	[170] = "\x8B",
	[SKINCOLOR_PIGEON] = "\x8C",
	[76] = "\x8C",
	[78] = "\x8C",
	[105] = "\x8C",
	[106] = "\x8C",
	[182] = "\x8C",
	[186] = "\x8C",
	[187] = "\x8C",
	[190] = "\x8C",
	[196] = "\x8C",
	[204] = "\x8C",
	[SKINCOLOR_FAIRY] = "\x8D",
	[SKINCOLOR_SALMON] = "\x8D",
	[SKINCOLOR_PINK] = "\x8D",
	[SKINCOLOR_ROSE] = "\x8D",
	[SKINCOLOR_BRICK] = "\x8D",
	[SKINCOLOR_LEMONADE] = "\x8D",
	[92] = "\x8D",
	[100] = "\x8D",
	[129] = "\x8D",
	[130] = "\x8D",
	[134] = "\x8D",
	[135] = "\x8D",
	[136] = "\x8D",
	[145] = "\x8D",
	[146] = "\x8D",
	[199] = "\x8D",
	[201] = "\x8D",
	[SKINCOLOR_SEPIA] = "\x8E",	
	[SKINCOLOR_BEIGE] = "\x8E",	
	[SKINCOLOR_WALNUT] = "\x8E",
	[SKINCOLOR_BROWN] = "\x8E",	
	[SKINCOLOR_LEATHER] = "\x8E",
	[80] = "\x8E",
	[81] = "\x8E",
	[107] = "\x8E",
	[108] = "\x8E",
	[133] = "\x8E",
	[148] = "\x8E",
	[151] = "\x8E",
	[152] = "\x8E",
	[SKINCOLOR_PEACH] = "\x8F",
	[SKINCOLOR_CARAMEL] = "\x8F",
	[SKINCOLOR_CREAM] = "\x8F",
	[109] = "\x8F",
	[110] = "\x8F",
	[183] = "\x8F",
}

--          General use functions

local function blueprefix() -- SHUT UP SHUT UP SHUT UP
	if CV_FindVar("fr_bluecolorlocal") and CV_FindVar("fr_bluecolorlocal") .value
		return colLookup[CV_FindVar("fr_bluecolorlocal") .value]
	end
	if CV_FindVar("fr_bluecolor") then
		return colLookup[CV_FindVar("fr_bluecolor") .value]
	end
		return "\x84"
end

local function orangeprefix() -- NIGHTMARE NIGHTMARE NIGHTMARE NIGHTMARE
	if CV_FindVar("fr_orangecolorlocal") and CV_FindVar("fr_orangecolorlocal") .value
		return colLookup[CV_FindVar("fr_orangecolorlocal") .value]
	end
	if CV_FindVar("fr_orangecolor") then
		return colLookup[CV_FindVar("fr_orangecolor") .value]
	end
		return "\x87"
end

--Converts MAPXX format into full integer values

--Needs specifics with the new map id system, may be changes here.
local function ConvertMapID(mapID)
	--Just in case scrubbing
	mapID = string.gsub(tostring(mapID), "map", "")
	mapID = string.gsub(tostring(mapID), "MAP", "")
	--If there's no letters in the ID then we don't need to do anything
	if tonumber(mapID) ~= nil then
		return mapID
	end
	--Too long/short to be a valid map ID at this point
	if #mapID > 2 or #mapID < 2 then
		return -1
	end
	
	--Char in C++ converts to int, lua doesn't have that luxury, so...
	local conDig = {
		['a'] = 0, ['A'] = 0,
		['b'] = 1, ['B'] = 1,
		['c'] = 2, ['C'] = 2,
		['d'] = 3, ['D'] = 3,
		['e'] = 4, ['E'] = 4,
		['f'] = 5, ['F'] = 5,
		['g'] = 6, ['G'] = 6,
		['h'] = 7, ['H'] = 7,
		['i'] = 8, ['I'] = 8,
		['j'] = 9, ['J'] = 9,
		['k'] = 10, ['K'] = 10,
		['l'] = 11, ['L'] = 11,
		['m'] = 12, ['M'] = 12,
		['n'] = 13, ['N'] = 13,
		['o'] = 14, ['O'] = 14,
		['p'] = 15, ['P'] = 15,
		['q'] = 16, ['Q'] = 16,
		['r'] = 17, ['R'] = 17,
		['s'] = 18, ['S'] = 18,
		['t'] = 19, ['T'] = 19,
		['u'] = 20, ['U'] = 20,
		['v'] = 21, ['V'] = 21,
		['w'] = 22, ['W'] = 22,
		['x'] = 23, ['X'] = 23,
		['y'] = 24, ['Y'] = 24,
		['z'] = 25, ['Z'] = 25,
	}
	--Letters in digit 2 are conDig[] + 10
	local Digit1 = 0
	local Digit2 = 0
	for i = 1, #mapID do
		local c = mapID:sub(i, i)
		if tonumber(c) ~= nil then
			if i == 1 then
				Digit1 = c
			else
				Digit2 = c
			end
		else
			if conDig[tostring(c)] == nil then
				--Invalid character
				return -1
			end
			if i == 1 then
				Digit1 = conDig[tostring(c)]
			else
				Digit2 = conDig[tostring(c)] + 10
			end
		end
	end
	return ((36 * Digit1 + Digit2) + 100)
end

--May be outdated for DRRR
local function ConvertToExtMapNumber(mapInt)
	mapInt = tonumber(mapInt) --Never assume shit, lua will murder you in your sleep for it.
	if not mapInt then return nil end
	if mapInt <= 99 then
		--No extention here
		return mapInt
	end
	
	--QUOTH THE WIKI
	--x: The integer minus 100.
	--p: x divided by 36. If you get a decimal, round down.
	--q: The remainder when x is divided by 36. You can determine this by (x - (36*p)).
	--a: The letter of the alphabet at the position p. The numbering begins at zero, so 2 would be C.
	--b: The letter of the alphabet at the position q. The numbering begins at ten, so 12 would be C. If q is less than ten, b should be the same as q.
	
	local x = mapInt - 100
	local p = x / 36
	local q = x - 36 * p
	local conDig = {
		[0] = 'A',
		[1] = 'B',
		[2] = 'C',
		[3] = 'D',
		[4] = 'E',
		[5] = 'F',
		[6] = 'G',
		[7] = 'H',
		[8] = 'I',
		[9] = 'J',
		[10] = 'K',
		[11] = 'L',
		[12] = 'M',
		[13] = 'N',
		[14] = 'O',
		[15] = 'P',
		[16] = 'Q',
		[17] = 'R',
		[18] = 'S',
		[19] = 'T',
		[20] = 'U',
		[21] = 'V',
		[22] = 'W',
		[23] = 'X',
		[24] = 'Y',
		[25] = 'Z',
	}
	
	local a = conDig[p]
	local b = q
	if q >= 10 then
		--Convert to letter
		b = conDig[q-10]
	end
	--print("result "..tostring(a)..tostring(b))
	return tostring(a)..tostring(b)
end

--Verify that the inputted map set has valid IDs, and the map actually exists before starting
local function VerifyMapSet(player, inputTable)
	if inputTable == nil then
		CONS_Printf(player, "\nNo map ID found! Enter Map IDs, seperated by spaces.")
		CONS_Printf(player, "\nEX: ATO_StartSet map24 mapa3 map21 map1")
		return false
	end
	--Assemble table of maps
	local mapList = {}
	local count = 0
	for k, v in ipairs(inputTable) do
		local holder = ConvertMapID(v)
		if holder != -1 then
			table.insert(mapList, holder)
			count = $ + 1
		else
			CONS_Printf(player, tostring(v).." is an invalid MapID")
			return false
		end
	end	
	--Verify that each item is selecting a valid map
	for _, mapID in ipairs(mapList) do
		if mapheaderinfo[tostring(mapID)] == nil then
			CONS_Printf(player, "\nMap ID "..tostring(mapID).." was not found. Set not started.")
			return false
		end
	end
	--Load the validated data and begin the set
	aTourney.tourneyMapList = mapList
	aTourney.totalMaps = count
	aTourney.raceNumber = 0
	aTourney.tourneyInSet = true
	didAnnounce = false
	slideRun = "left"
	slideValue = -50
	slideDelay = 0
	didCommand = false
	tIntCounter = CV_FindVar("inttime").value * TICRATE
	staticIntRef = CV_FindVar("inttime").value * TICRATE
	aTourney.bluetotalscore = 0
	aTourney.orangetotalscore = 0
	return true
end

--Sorting function
local function spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end

local function PrintScores()
	--Some Elim/Friendmod code is here from Freeman
	local stuffToSort = {}
	local playerObjects = {}
	local sortedplayers = {}
	local blueTeam = "Blue"
	local orangeTeam = "Orange"
	if CV_FindVar("fr_enabled") and CV_FindVar("fr_enabled").value then
		--I can only support manually set team names here as the random names aren't exposed in Friendmod
		if CV_FindVar("fr_bluename").string ~= "Random" then
			blueTeam = CV_FindVar("fr_bluename").string
		end
		if CV_FindVar("fr_orangename").string ~= "Random" then
			orangeTeam = CV_FindVar("fr_orangename").string
		end
	end
	--ignore spectators
	for p in players.iterate do
		if p.valid then
			if not aTourney.LogSpectatorScores.value and p.mo ~= nil and p.mo.valid then
				stuffToSort[p.name] = p.score
				playerObjects[p.name] = p
				table.insert(sortedplayers, p)
			elseif aTourney.LogSpectatorScores.value then
				stuffToSort[p.name] = p.score
				playerObjects[p.name] = p
				table.insert(sortedplayers, p)
			end				
		end
	end
	if logMapBuffer then --..just in case. Scores are important.
		print("\x85**SCORE PRINTOUT** \x83Race Number "..tostring(aTourney.raceNumber).." \x87"..logMapBuffer)
		if CV_FindVar("fr_enabled") and CV_FindVar("fr_enabled").value then
			print("TEAM "..blueprefix()..blueTeam.."\128 VS TEAM "..orangeprefix()..orangeTeam)
		end
		if elimtoggle and elimtoggle.el_enabled.value then
			print("                         \131TOTAL\128| \133THIS ROUND")
			print("\131##\128| \131NAME                 \128| \131PTS\128|    \133DMG\128|    \135CMB\128|    \131KIL")
		else
			print("\131##\128| \131NAME                 \128| \131PTS")
		end	
	end
	if CV_FindVar("fr_enabled") and CV_FindVar("fr_enabled").value then
		table.sort(playerObjects,function(a, b)
			return a.personalscore > b.personalscore
		end)
		local i = 0
		local bluetotalthisround = 0
		local orangetotalthisround = 0
		for _, q in ipairs(sortedplayers)
			i=$+1
			local pos = "??"
			local pname = "WHO THE FUCK??"
			local pscore = "##??" // I dont care if this actually ever shows up but it will be funny if it does
			if q.FRteam == 1 then
				pos = string.format("%02i",i)
				pname = blueprefix()..string.format("%-20s",q.name)
				pscore = blueprefix()..string.format("%4s",q.personalscore)
				bluetotalthisround = $+q.personalscore
			else
				pos = string.format("%02i",i)
				pname = orangeprefix()..string.format("%-20s",q.name)
				pscore = orangeprefix()..string.format("%4s",q.personalscore)
				orangetotalthisround = $+q.personalscore
			end
			print("\130"..pos.."\128| "..pname.." |\132"..pscore)
		end
		print(string.rep("-",31))
		print("THIS ROUND: "..blueprefix()..bluetotalthisround.."\128 - "..orangeprefix()..orangetotalthisround)
		aTourney.bluetotalscore = $+bluetotalthisround
		aTourney.orangetotalscore = $+orangetotalthisround
		print("GRAND TOTAL: "..blueprefix()..aTourney.bluetotalscore.."\128 - "..orangeprefix()..aTourney.orangetotalscore)
	else
		local posCounter = 1
		local lastScore = -1
		local tiePosTracker = -1
		for k,v in spairs(stuffToSort, function(t,a,b) return t[a] > t[b] end) do
			local posString = tostring(posCounter)
			if lastScore == v then
				--This player is tied with the last one
				posString = tostring(tiePosTracker)
			else
				tiePosTracker = posCounter
			end
			lastScore = v
			--Empty space around name length - 25
			local padPointer = string.len(k)
			local namepadding = ""
			while (padPointer < 21)
			do
				namepadding = $.." "
				padPointer = $ + 1
			end
			padPointer = string.len(v)
			local scorepadding = ""
			while (padPointer < 4)
			do
				scorepadding = $.." "
				padPointer = $ + 1
			end
			if string.len(posString) == 1 then
				posString = " "..$
			end
			--Elimination specific data
			local elimString = ""
			if elimtoggle and elimtoggle.el_enabled.value and playerObjects[k] and playerObjects[k].hpmod then
				padPointer = string.len(playerObjects[k].hpmod.damageDealt.damage)
				local damagepadding = ""
				while (padPointer < 6)
				do
					damagepadding = $.." "
					padPointer = $ + 1
				end
				padPointer = string.len(playerObjects[k].hpmod.bestCombo.totalPoints)
				local combopadding = ""
				while (padPointer < 6)
				do
					combopadding = $.." "
					padPointer = $ + 1
				end
				padPointer = string.len(playerObjects[k].hpmod.kills)
				local killpadding = ""
				while (padPointer < 6)
				do
					killpadding = $.." "
					padPointer = $ + 1
				end
				
				elimString = "\x80| \133"..damagepadding..playerObjects[k].hpmod.damageDealt.damage.."\x80| \135"..combopadding..playerObjects[k].hpmod.bestCombo.totalPoints.."\x80| \131"..killpadding..playerObjects[k].hpmod.kills		
			end
			
			--if combowinner == nil then combowinner = {p.name, p.mo.skin, p.skincolor, p.hpmod.bestCombo.points, p.hpmod.bestCombo.damage, p.hpmod.bestCombo.hits} end
			--if biggestguy == nil then biggestguy = {p.name, p.mo.skin, p.skincolor, p.hpmod.damageDealt.damage, p.hpmod.damageDealt.hits} end
			--if mostkills == nil then mostkills = {p.name, p.mo.skin, p.skincolor, p.hpmod.kills} end
			
			print("\x82"..tostring(posString).."\x80| "..k..namepadding.."|\x84"..scorepadding..tostring(v)..elimString)
			posCounter = $ + 1
		end
	end
	print("\x80______________________________")
end

--          Commands
--I wonder what this does
local function ClearScores(player)
	if (IsPlayerAdmin(player) or player == server) then
		COM_BufInsertText(server, "clearscores")
		chatprint("\133<TOURNEY>\x83 Scores have been reset", true)
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")	
		return
	end
end
COM_AddCommand("ATO_ClearScores", ClearScores)

local function ClearSet(player)
	if (IsPlayerAdmin(player) or player == server) and aTourney.tourneyInSet then
		aTourney.tourneyMapList = {}
		aTourney.tourneyInSet = false
		if TRCups then
			TRCups.currentcup = nil
		end
		didAnnounce = false
		slideRun = "left"
		slideValue = -50
		slideDelay = 0
		didCommand = false
		savedScores = {}
		tIntCounter = CV_FindVar("inttime").value * TICRATE
		staticIntRef = CV_FindVar("inttime").value * TICRATE
		aTourney.isRandomSet = false
		aTourney.bluetotalscore = 0
		aTourney.orangetotalscore = 0
		lastRaceOfRandom = false
		COM_BufInsertText(server, "csay Tourney set has been cancelled")
		CONS_Printf(player, "\nTourney set has been cancelled")	
	else
		CONS_Printf(player, "\nThere is no active set or you are not an admin.")	
	end
end
COM_AddCommand("ATO_ClearSet", ClearSet)

local function ShowSetMaps(player)
	if aTourney.tourneyInSet and not aTourney.isRandomSet then
		CONS_Printf(player, "Upcoming maps, in order:")
		for k, v in ipairs(aTourney.tourneyMapList) do
			--These were already vetted, so we know they exist.
			--R-right?
			CONS_Printf(player, mapheaderinfo[tostring(v)].lvlttl.." "..mapheaderinfo[tostring(v)].zonttl)
		end
	elseif aTourney.isRandomSet then
		CONS_Printf(player, "Set is running with random/voted maps.")
	else
		CONS_Printf(player, "A set is not running.")
	end
end
COM_AddCommand("ATO_ShowSetMaps", ShowSetMaps)

local function StartSet(player, ...)
	if (IsPlayerAdmin(player) or player == server) then
		if aTourney.tourneyInSet then
			CONS_Printf(player, "\nA tourney is already running. Use ATO_ClearSet to stop it.")	
			return
		end
		if CV_FindVar("advancemap") and CV_FindVar("advancemap").value ~= 3 then
			CONS_Printf(player, "\nSet advancemap 3 before runnining this command.")
			return
		end
		local checkTable = {...}
		if VerifyMapSet(player, checkTable) then
			clearscoreflag = true
			aTourney.isRandomSet = false
			ShowSetMaps(player)			
			
			chatprint("\133<TOURNEY>\x83 A set is starting!", true)
			chatprint("\133<TOURNEY>\x83 Set now running for ".. tostring(aTourney.totalMaps).." maps!", true)
			if roundstatus == RS_THINK then
				COM_BufInsertText(server, "exitlevel")
			elseif roundstatus == RS_VOTE then --Don't do this unless you've told players it's starting, because it's going to start immediately
				--Move maps NOW
				aTourney.raceNumber = 1
				chatprint("\133<TOURNEY>\x83 Up Now: "..mapheaderinfo[tostring(aTourney.tourneyMapList[1])].lvlttl.." "..mapheaderinfo[tostring(aTourney.tourneyMapList[1])].zonttl, true)
				if aTourney.raceNumber >= aTourney.totalMaps then
					chatprint("\133<TOURNEY>\x85 LAST RACE OF THE SET!", true) --Bro, you made a set with one map?
				else
					chatprint("\133<TOURNEY>\x83 Race #"..tostring(aTourney.raceNumber).." of "..tostring(aTourney.totalMaps), true)	
				end
				COM_BufInsertText(server, "map "..tostring(aTourney.tourneyMapList[1]))
			end
			
		end		
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")	
	end
end
COM_AddCommand("ATO_StartSet", StartSet)

local function StartRandomSet(player, count)
	if (IsPlayerAdmin(player) or player == server) then
		if aTourney.tourneyInSet then
			CONS_Printf(player, "\nA tourney is already running. Use ATO_ClearSet to stop it.")	
			return
		end
		if roundstatus == RS_VOTE then
			CONS_Printf(player, "\nCan't run this on the vote screen - ATO doesn't handle random map changing so your first map will not be random!")	
			return	
		end
		if count == nil or tonumber(count) == nil then
			CONS_Printf(player, "\nUsage: ATO_StartRandomSet [Number of races]")	
			return	
		end
		
		--All checks passed
		aTourney.totalMaps = tonumber(count)
		aTourney.raceNumber = 0
		aTourney.tourneyInSet = true
		didAnnounce = false
		slideRun = "left"
		slideValue = -50
		slideDelay = 0
		didCommand = false
		tIntCounter = CV_FindVar("inttime").value * TICRATE
		staticIntRef = CV_FindVar("inttime").value * TICRATE
		aTourney.isRandomSet = true
		clearscoreflag = true
		aTourney.bluetotalscore = 0
		aTourney.orangetotalscore = 0
		
		chatprint("\133<TOURNEY>\x83 A set is starting!", true)
		chatprint("\133<TOURNEY>\x83 Set now running for ".. tostring(aTourney.totalMaps).." maps!", true)
		if roundstatus == RS_THINK then
			COM_BufInsertText(server, "exitlevel")
		end
	else
		CONS_Printf(player, "\nYou must be an admin to use this command.")	
	end
end
COM_AddCommand("ATO_StartRandomSet", StartRandomSet)

--          Hooks

local function ThinkFrame()
	if aTourney.tourneyInSet and roundstatus != RS_THINK then
		--Progress the tourney
		didAnnounce = false
		slideRun = "left"
		slideValue = -50
		slideDelay = 0
		didCommand = false
		lastRaceOfRandom = false
		if not aTourney.isRandomSet then
			logMapBuffer = mapheaderinfo[tostring(aTourney.tourneyMapList[1])].lvlttl.." "..mapheaderinfo[tostring(aTourney.tourneyMapList[1])].zonttl
			table.remove(aTourney.tourneyMapList, 1)
		elseif mapheaderinfo[gamemap]
			logMapBuffer = mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl
		end
		
		if clearscoreflag == true then
			--Wipe scores at the start of the first round
			COM_BufInsertText(server, "ATO_ClearScores")
			clearscoreflag = false
		end
		
		tIntCounter = CV_FindVar("inttime").value * TICRATE --Reset intermission timer
		staticIntRef = CV_FindVar("inttime").value * TICRATE
	end
	
	if aTourney.tourneyInSet then
		--Monitor to see if a disconnected player returned yet.
		for p in players.iterate do
			if p.valid and savedScores[p.name] then
				print("\x85**RECONNECTION** "..p.name.." has reconnected. Assigning them their saved score of \x83"..tostring(savedScores[p.name]))
				p.score = savedScores[p.name]
				savedScores[p.name] = nil
			end
		end
	end
	
	roundstatus = RS_THINK
end
addHook("ThinkFrame", ThinkFrame)

local function IntermissionThinker()
	roundstatus = RS_INT
	
	if aTourney.tourneyInSet and not didCommand then
		if not didAnnounce then -- print announcements
			didAnnounce = true
			
			if aTourney.raceNumber != 0 then
				PrintScores()
			end
			
			if aTourney.raceNumber < aTourney.totalMaps then
				aTourney.raceNumber = $ + 1
				
				if aTourney.isRandomSet then
					if aTourney.raceNumber >= aTourney.totalMaps then
						chatprint("\133<TOURNEY>\x83 Up Next: \x85LAST RACE OF THE SET!", true)
						lastRaceOfRandom = true
					elseif aTourney.raceNumber < aTourney.totalMaps then
						chatprint("\133<TOURNEY>\x83 Up Next: Race #"..tostring(aTourney.raceNumber).." of "..tostring(aTourney.totalMaps), true)	
					end
				else
					chatprint("\133<TOURNEY>\x83 Up Next: "..mapheaderinfo[tostring(aTourney.tourneyMapList[1])].lvlttl.." "..mapheaderinfo[tostring(aTourney.tourneyMapList[1])].zonttl, true)
					if aTourney.raceNumber >= aTourney.totalMaps then
						chatprint("\133<TOURNEY>\x85 LAST RACE OF THE SET!", true)
						lastRaceOfRandom = true --This variable name doesn't make sense anymore but nobody's reading this anyway...right?
					else
						chatprint("\133<TOURNEY>\x83 Race #"..tostring(aTourney.raceNumber).." of "..tostring(aTourney.totalMaps), true)	
					end				
				end
			elseif aTourney.raceNumber >= aTourney.totalMaps and not lastRaceOfRandom then
				chatprint("\133<TOURNEY>\x83 THE SET HAS CONCLUDED! Let's see who won!", true)
			end			
		end
		
		if tIntCounter > 15 then --give it a little buffer.
			tIntCounter = max(0, $-1)
			return --fuck off until then
		end
		
		if (aTourney.raceNumber < aTourney.totalMaps or lastRaceOfRandom) and not aTourney.isRandomSet then --Swap maps over, random sets let the game do it's thing
			COM_BufInsertText(server, "map "..tostring(aTourney.tourneyMapList[1]))
		elseif aTourney.raceNumber >= aTourney.totalMaps and not lastRaceOfRandom then
			if aTourney.PauseOnSetEnd.value then
				tIntCounter = CV_FindVar("inttime").value * TICRATE
				staticIntRef = CV_FindVar("inttime").value * TICRATE
				aTourney.tourneyInSet = false
				if TRCups then
					TRCups.currentcup = nil
				end
				savedScores = {}
				COM_BufInsertText(server, "pause")
			else
				aTourney.tourneyInSet = false
				if TRCups then
					TRCups.currentcup = nil
				end
				savedScores = {}
			end	
		end
		
		didCommand = true		
	end
end
addHook("IntermissionThinker", IntermissionThinker)

local function VoteThinker()
	roundstatus = RS_VOTE --This used to do stuff but now it's just here to keep track
end
addHook("VoteThinker", VoteThinker)

--interscreen - Show the next map's icon
local function hudIntermissionThinker(v)
	if aTourney.tourneyInSet and not aTourney.isRandomSet and aTourney.ShowNextMap.value and slideRun ~= "stop" then
		if not aTourney.tourneyMapList[1] or not ConvertToExtMapNumber(aTourney.tourneyMapList[1]) then
			--It's over........
			slideRun = "stop"
			return
		end
		local MapGraphicString = "MAP"..ConvertToExtMapNumber(aTourney.tourneyMapList[1]).."P"
		if tonumber(ConvertToExtMapNumber(aTourney.tourneyMapList[1])) and ConvertToExtMapNumber(aTourney.tourneyMapList[1]) <= 9 then --edge case we need to format for
			MapGraphicString = "MAP0"..tostring(ConvertToExtMapNumber(aTourney.tourneyMapList[1])).."P"
			if not v.patchExists(MapGraphicString) then
				slideRun = "stop"
				return
			end
		elseif not v.patchExists(MapGraphicString) then
			--No icon found
			slideRun = "stop"
			return
		end
		
		if slideRun ~= "stop" then
			--Slide in the map icon from the right.
			local screenYSub = 60
			local textYSub = 68
			
			local scrwidth = v.width()/v.dupx();
			local winheight = v.height()/v.dupy();
			local windiff = ((winheight-200)/2)
			local right = ((scrwidth+75)/2);
			local elimMode = false
			
			--width - 3440 dupx - 7
			local hudFlags = V_30TRANS
			if elimtoggle and elimtoggle.el_enabled.value then
				elimMode = true
				hudFlags = V_SNAPTOLEFT|V_30TRANS
			end

			--Left this here for example of popup sliding in and out
			if slideRun == "left" then
				slideValue = $ + 1			
				if slideValue >= 7 then
					slideRun = "delay"
				end
			elseif slideRun == "delay" then
				slideDelay = $ + 1
				if slideDelay >= staticIntRef - (3 * TICRATE) then
					slideRun = "right"
				end
			elseif slideRun == "right" then
				slideValue = $ - 1
				if slideValue <= -50 then
					slideRun = "stop"
				end
			end
			--print(slideValue)
			
			--v.draw((65-(slideValue*5))+right, ((winheight-windiff)-screenYSub), v.cachePatch("MAP"..tourneyMapList[1].."P"), flags)
			--Need to convert x/y to FRACUNIT here
			local xIcon = ((55-(slideValue*5))+right)*FRACUNIT -- -10
			local yIcon = (((winheight-windiff)-screenYSub))*FRACUNIT
			
			if elimMode then
				xIcon = 5*FRACUNIT
			end
			
			v.drawScaled(xIcon, yIcon, FRACUNIT/2, v.cachePatch(MapGraphicString), hudFlags)
			local headerWidth = v.stringWidth("UP NEXT", hudFlags)
			local texty = ((winheight-windiff)-textYSub)
			
			-- Cup Related stuff for TRC
			local cupname = TRCups.currentcup and TRCups.currentcup.title or "Tourney Set"
			local cupNameLen = string.len(cupname)
			local shortname = (cupNameLen < 11)
			local cupNameScale = shortname and 2*FRACUNIT/4 or FRACUNIT/4
			local yoffset = shortname and 10 or 5
			
			if elimMode then
				v.drawString(5, texty, "\x82UP NEXT", hudFlags)
				if ULTIMATEDRAWSTRING then
					FNT_Write(v,{x = 5 * FRACUNIT, y = (texty-yoffset) * FRACUNIT, text = cupname,font = FONT_S2FNT, scale = cupNameScale,
						color = SKINCOLOR_WHITE, flags = hudFlags})
				end
			else
				local textx = (107-((slideValue)*5))+(right - headerWidth)
				v.drawString(textx, texty, "\x82UP NEXT", hudFlags)
				if ULTIMATEDRAWSTRING then
					FNT_Write(v,{x = textx * FRACUNIT, y = (texty-yoffset) * FRACUNIT, text = cupname,font = FONT_S2FNT, scale = cupNameScale,
						color = SKINCOLOR_WHITE, flags = hudFlags})
				end
			end
			
		end
	end
end
hud.add(hudIntermissionThinker, "intermission")

local function PlayerQuit(p, r)
	--Save a disconnecting player's score
	if aTourney.tourneyInSet and not clearscoreflag then
		local dr = "Player Left"
		if r == KR_KICK then
			dr = "Player was kicked"
		elseif r == KR_PINGLIMIT
			dr = "Player broke pinglimit"
		elseif r == KR_SYNCH
			dr = "Player synchfailed"
		elseif r == KR_TIMEOUT
			dr = "Player timed out"
		elseif r == KR_BAN
			dr = "Player was banned"
		end
		print("\x85**DISCONNECTION** "..p.name.." disconnected in race number \x83"..tostring(aTourney.raceNumber).." \x85with a score of \x83"..tostring(p.score).." \x85 Leave reason - \x83"..dr)
		if p.score > 0 then
			savedScores[p.name] = p.score
		end		
	end
end
addHook("PlayerQuit", PlayerQuit)

--          Netsyncs
--Just sync everything, don't risk it when it comes to a tourney
addHook("NetVars", function(n)
	aTourney.tourneyMapList = n($)
	aTourney.raceNumber = n($)
	aTourney.totalMaps = n($)
	aTourney.tourneyInSet = n($)
	aTourney.slideRun = n($)
	aTourney.slideValue = n($)
	aTourney.slideDelay = n($)
	didAnnounce = n($)
	clearscoreflag = n($)
	roundstatus = n($)
	tIntCounter = n($)
	logMapBuffer = n($)
	savedScores = n($)
	aTourney.isRandomSet = n($)
	aTourney.bluetotalscore = n($)
	aTourney.orangetotalscore = n($)
	lastRaceOfRandom = n($)
	didCommand = n($)
end)

