-----------------------------------
--	    Transcendence Cups		 --
--  Lua by NepDisk, Idea by luna --
--			  Cups				 --
-- 	 Cups are registered here    --
-----------------------------------

local TRCups = TRCups
local cups = TRCups.cups

if TRCups == nil then
	error("There is no TRCups namespace, this script will therefore not run.")
	return
end

-- Cup Definitions contain:
-- you can exclude stuff you don't have a need for, but maplist and mapload are required.
-- title: name of cup
-- mapload: map that loads cup
-- maplist: list of maps in cup
-- cupcreator: creator of cup, shown in TRC_CupInfo
-- cupdesc: description of cup, shown in TRC_CupInfo

local cupLuna1 = {
	title = "Youkai Cup",
	mapload = "29",
	maplist = {"W1", "TQ", "MC", "ZQ", "ZR", "RJ"},
	cupcreator = "Luna",
	cupdesc = ""
}
table.insert(cups, cupLuna1)

local cupLuna2 = {
	title = "Interplanetary Cup",
	mapload = "GM",
	maplist = {"76", "PH", "KX", "RM", "PG"},
	cupcreator = "Luna",
	cupdesc = ""
}
table.insert(cups, cupLuna2)

local cupLuna3 = {
	title = "Clamorous Cup",
	mapload = "GK",
	maplist = {"FC", "UZ", "UQ", "GQ", "WX", "78"},
	cupcreator = "Luna",
	cupdesc = ""
}
table.insert(cups, cupLuna3)

local cupLuna4 = {
	title = "Denki Cup",
	mapload = "E0",
	maplist = {"L5", "C5", "GX", "OW", "75", "FB"},
	cupcreator = "Luna",
	cupdesc = ""
}
table.insert(cups, cupLuna4)

local cupSwift1 = {
	title = "Sunset Cup",
	mapload = "CA",
	maplist = {"E7", "AT", "11", "DR", "CS"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift1)

local cupSwift2 = {
	title = "Golden Sun Cup",
	mapload = "P9",
	maplist = {"EZ", "FO", "GS", "EV", "EY"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift2)

local cupSwift3 = {
	title = "Sprint Cup",
	mapload = "MZ",
	maplist = {"JT", "14", "VE", "NR", "K4"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift3)

local cupSwift4 = {
	title = "Industrial Cup",
	mapload = "MX",
	maplist = {"25", "64", "L4", "RE", "U9", "VN"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift4)

local cupSwift5 = {
	title = "Ice & Fire Cup",
	mapload = "B0",
	maplist = {"", "", "", "", ""},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift5)

local cupSwift6 = {
	title = "Eden Cup",
	mapload = "MQ",
	maplist = {"K8", "UW", "K5", "V5", "FB", "V6"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift6)

local cupSwift7 = {
	title = "Uncharted Cup",
	mapload = "BH",
	maplist = {"JJ", "K3", "FR", "MI", "O0", "WV"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift7)

local cupSwift8 = {
	title = "War of Shadows",
	mapload = "HG",
	maplist = {"XS", "VA", "NS", "Y6", "CZ", "LQ"},
	cupcreator = "Swift",
	cupdesc = ""
}
table.insert(cups, cupSwift8)

local cupTom1 = {
	title = "Piston Cup",
	mapload = "ED",
	maplist = {"05", "DN", "97", "OJ", "52", "DM"},
	cupcreator = "Tom",
	cupdesc = ""
}
table.insert(cups, cupTom1)

local cupTom2 = {
	title = "Blacklist Cup",
	mapload = "I2",
	maplist = {"G4", "DZ", "M3", "YV", "DF", "GP"},
	cupcreator = "Tom",
	cupdesc = ""
}
table.insert(cups, cupTom2)

local cupKidd1 = {
	title = "Rush Cup",
	mapload = "HH",
	maplist = {"62", "63", "64", "67", "65", "66"},
	cupcreator = "Kidd",
	cupdesc = ""
}
table.insert(cups, cupKidd1)

local cupKidd2 = {
	title = "Sweet Cup",
	mapload = "HC",
	maplist = {"31", "DP", "CU", "W9", "CV", "F7"},
	cupcreator = "Kidd",
	cupdesc = ""
}
table.insert(cups, cupKidd2)

local cupKidd3 = {
	title = "Snow Bunny Cup",
	mapload = "55",
	maplist = {"Y9", "MO", "WC", "WS", "F7"},
	cupcreator = "Kidd",
	cupdesc = ""
}
table.insert(cups, cupKidd3)

local cupKiri1 = {
	title = "Zaza Cup",
	mapload = "YZ",
	maplist = {"KE", "SX", "G6", "WV", "MI", "UW"},
	cupcreator = "Evil Tiger",
	cupdesc = ""
}
table.insert(cups, cupKiri1)

local cupKiri2 = {
	title = "Lit Cup",
	mapload = "JS",
	maplist = {"40", "LR", "TK", "NH", "GN", "GW"},
	cupcreator = "Evil Tiger",
	cupdesc = ""
}
table.insert(cups, cupKiri2)

local cupVal1 = {
	title = "Rokkenjima Cup",
	mapload = "P7",
	maplist = {"IB", "CN", "WA", "HB", "65", "59"},
	cupcreator = "Cycoh",
	cupdesc = ""
}
table.insert(cups, cupVal1)

local cupRennala1 = {
	title = "Rennala's Vacation",
	mapload = "ZX",
	maplist = {"JO", "99", "LP", "YD", "ZU", "OW", "OV"},
	cupcreator = "Rennala",
	cupdesc = ""
}
table.insert(cups, cupRennala1)

local cupRennala2 = {
	title = "Spooky Cup",
	mapload = "S3",
	maplist = {"YD", "N7", "ME", "K7", "LQ", "A4"},
	cupcreator = "Rennala",
	cupdesc = ""
}
table.insert(cups, cupRennala2)

local cupSuroh1 = {
	title = "Vermillion Cup",
	mapload = "VH",
	maplist = {"RN", "CV", "EA", "GT", "NK", "W9"},
	cupcreator = "Suroh",
	cupdesc = ""
}
table.insert(cups, cupSuroh1)

local cupSuroh2 = {
	title = "A Dash of Lava",
	mapload = "83",
	maplist = {"C9", "K7", "F6", "NC", "UL", "VN"},
	cupcreator = "Suroh",
	cupdesc = ""
}
table.insert(cups, cupSuroh2)

local cupPrada1 = {
	title = "Bling Cup",
	mapload = "Y7",
	maplist = {"11", "JO", "L5", "XB", "LR", "59"},
	cupcreator = "Prada",
	cupdesc = ""
}
table.insert(cups, cupPrada1)

local cupPrada2 = {
	title = "Idol Cup",
	mapload = "36",
	maplist = {"LU", "X7", "W4", "W7", "GN"},
	cupcreator = "Prada",
	cupdesc = ""
}
table.insert(cups, cupPrada2)
