-----------------------------------
--	    Transcendence Cups		 --
--  Lua by NepDisk, Idea by luna --
--			  Main				 --
-- 	Handles the Main ATO Stuff   --
-----------------------------------

local aTourney = aTourney
local TRCups = TRCups
local cups = TRCups.cups

if TRCups == nil then
	error("There is no TRCups namespace, this script will therefore not run.")
	return 
end

if cups == nil then 
	error("There are no cups loaded, this script will therefore not run.")
	return
end

if aTourney == nil then
	error("ATO is not loaded, this script will therefore not run.")
elseif aTourney.trcVersion == nil then
	error("ATO is loaded but is not the version needed by TRC, this script will therefore not run.")
end

-- taken from maplist by Dr_Nope and freeman, converts gamemap to mapid for use in comparasion
local function getmapid(n)
    if n<100 then
        return (n<10) and ("0"..n) or tostring(n)
    end

    local x= n-100
    local p= x/36
    local q= x-(36*p)
    local a= string.char(string.byte('A')+p)
    local b= (q<10) and tostring(q) or string.char(string.byte('A')+q-10)

    return a..b
end

-- Starts a cup with its current contents.
local function startCup(cup)
	-- first build a string of maps
	local maps = ""
	for num, map in pairs(cup.maplist)
		maps = maps..map.." "
	end
	
	if aTourney and aTourney.tourneyInSet then 
		COM_BufInsertText(server, "ATO_ClearSet")
	end
	
	COM_BufInsertText(server, "ATO_StartSet "..maps)
end

addHook("MapLoad", do
	for i=1, #cups do
		if cups[i] == nil or cups[i].mapload == nil or cups[i].maplist == nil then continue end
		local currentgamemap = getmapid(gamemap)
		//print("currentgamemap: "..currentgamemap)
		if currentgamemap == cups[i].mapload then
			startCup(cups[i])
			TRCups.currentcup = cups[i]
		end
	end
end)
